phdru.name / Software / dotfiles

# sh/ksh/bash run commands
#
# Text version here
#
# Generated by gvim :runtime syntax/2html.vim
#
#
# $HOME/.shellrc
#

# ~/.bashrc: executed by bash(1) for non-login shells.
# see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
# for examples

# If not running interactively, don't do anything
case $- in
    *i*) ;;
      *) return ;;
esac

# Stop if non-interactive shell
[ -z "$PS1" ] && return

if test -n "$BASH_VERSION"; then
   # append to the history file, don't overwrite it
   shopt -s histappend

   # check the window size after each command and, if necessary,
   # update the values of LINES and COLUMNS.
   shopt -s checkwinsize

   # If set, the pattern "**" used in a pathname expansion context will
   # match all files and zero or more directories and subdirectories.
   #shopt -s globstar
fi


#if [ -x /usr/bin/dircolors ]; then
#   # I don't like these aliases - they work only in command line
#   # but not in scripts I run from command line.
#   # Color parameters must be passed via environment.
#   # So instead I put them in shell scripts in ~/bin.
#   alias ls='ls --color=auto'
#   alias dir='dir --color=auto'
#   alias vdir='vdir --color=auto'
#
#   alias grep='grep --color=auto'
#   alias fgrep='fgrep --color=auto'
#   alias egrep='egrep --color=auto'
#
#   alias dmesg='dmesg --human'
#fi


case "$HOME" in
   /home/*)
      if [ -L /home ]; then
         START_DIR="`pwd`" &&
         cd "$HOME" &&
         HOME="`pwd`" &&
         cd "$START_DIR"
      fi
   ;;
esac


OPS1="$OPS1\\$"
PS1="$OPS1 "


if test -n "$BASH_VERSION"; then
   [ "`type -t ls`" = alias ] && unalias ls
   [ "`type -t ll`" = alias ] && unalias ll
   [ "`type -t mc`" = alias ] && unalias mc

   back() { cd - "$@"; }
   functions() { typeset -f "$@"; }
   j() { jobs; }

   if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
      if [ "$SHELL" = /bin/bash ]; then
         if [ -f /etc/bash_completion ]; then
            . /etc/bash_completion
         elif [ -d /etc/bash_completion.d ]; then
            . /etc/bash_completion.d/*
         fi
      elif [ "$SHELL" = /usr/local/bin/bash ]; then
         if [ -d /usr/local/etc/bash_completion.d ]; then
            . /usr/local/etc/bash_completion.d/*
         fi
      else
         echo "Unknown OS type, canot source bash_completion" >&2
      fi
   fi

   has_completion() { return 0; }
   if [ "$SHELL" = /bin/bash ]; then
      if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
         has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
      fi
   elif [ "$SHELL" = /usr/local/bin/bash ]; then
      if [ -d /usr/local/etc/bash_completion.d ]; then
         has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
      fi
   fi

   for cmd in builtin cgmem_nice command dbus-launch exec \
      killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
      time whence whereis which xargs; do
         ! has_completion $cmd && complete -o default -A command $cmd
   done

   for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
      telnet t tt \
      tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
      whois wget wget-m wget-wrapper ww; do
         ! has_completion $cmd && complete -A hostname $cmd
   done

   for cmd in distribute ftp lftp r rsync \
      s scp ssh smbclient tcpdump tshark wireshark; do
         ! has_completion $cmd && complete -o default -A hostname $cmd;
   done

   delegate_completion() {
      local prog completion_f programs
      prog="$1"
      if has_completion "$prog"; then
         completion_f="$2"
         shift; shift
         programs="$@"
         eval "_${prog}_completion_loader() {
            _completion_loader $prog
            complete -F $completion_f $programs
            unset _${prog}_completion_loader
            return 124
         }"
         complete -F _"$prog"_completion_loader $programs
      fi
   }

   delegate_completion make _make m
   delegate_completion ping _ping p
   delegate_completion rsync _rsync r
   delegate_completion ssh _ssh s
   delegate_completion wget _wget wget-m wget-wrapper ww

   unset has_completion delegate_completion

   complete -A job bg fg j jobs wait
   complete -A variable -A function unset

   if [ -d "$HOME/lib/config" ]; then
      complete -W "`cd \"$HOME/lib/config\" && echo *`" include
   fi
   complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser

   #if type -p pip >/dev/null 2>&1; then
   #   eval "`pip completion --bash`"
   #   rm -rf /tmp/pip_build_"$USER"
   #fi

   #if which pyenv >/dev/null 2>&1; then
   #   eval "`pyenv init -`"
   #   eval "`pyenv virtualenv-init -`"
   #fi

   source virtualenvwrapper_lazy.sh 2>/dev/null

   #if [ -n "$VIRTUAL_ENV" ]; then
   #   . "$VIRTUAL_ENV/bin/activate"
   #fi

elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
   back() { cd - "$@"; }
   j() { jobs; }
fi


# clear screen and history, logout
chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }


if test -x /usr/bin/git >/dev/null 2>&1; then
   # chdir to a remote's directory (if the remote is on the local FS)
   cdremote() {
      if [ -z "$1" -o -n "$2" ]; then
         echo "Usage: cdremote remote_name" >&2
         return 1
      fi
      cd "`git config --get remote.$1.url`"
   }

   if test -n "$BASH_VERSION"; then
      # completion for global aliases in .gitconfig

      # fixup rbi rbia rbiap rbip - do refs name completion
      _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
      _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
      _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
      _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
      _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
      #
      # push-to-all-remotes - do branch name completion
      _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }

      # list remotes with URLs matching a regexp
      _list_remotes() {
         if [ -z "$1" -o -n "$2" ]; then
            echo "Usage: _list_remotes remote_regexp" >&2
            return 1
         fi
         GIT_REMOTES=""
         local remote
         for remote in `git remote`; do
            if git config --get remote.$remote.url | grep -q "$1"; then
               GIT_REMOTES="$GIT_REMOTES $remote"
            fi
         done
      }

      # completion for cdremote and git-open - list remotes with a pattern
      _list_remotes_completion() {
         local cur="${COMP_WORDS[COMP_CWORD]}";
         _list_remotes "$1"
         COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
         unset GIT_REMOTES
      }

      # completion for cdremote - list remotes with directories as URLs
      _cdremote_complete() {
         _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
      }

      complete -F _cdremote_complete cdremote

      # completion for git-open - list remotes with http(s) URLs
      _git_open() {
         _list_remotes_completion '^http\(s\)\?://'
      }

      complete -F _git_open git-open
   fi
fi


include() {
   cfg="$1"
   if [ -f "./$cfg" -a -r "./$cfg" ]; then
      echo "Reading config file \`$cfg'" 1>&2
      . "./$cfg"
   elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
      echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
      . "$HOME/lib/config/$cfg"
   else
      echo "Cannot find config file \`$cfg'" 1>&2
   fi
}


mc() {
   if test -n "$BASH_VERSION"; then
      MC_SAVE_OPS1="$OPS1"
      OPS1="\u@\h "
   fi

   if [ -n "$SLOWTERM" ]; then
      MC_SLOW="--slow"
   fi

   case "$TERM" in
      screen*) # screen, screen.rxvt
         if [ "$TERM" = screen.rxvt ]; then
            MC_SAVE_TERM="$TERM"
            TERM=rxvt
         fi
         MC_XTERM="-x"
      ;;
   esac

   #TMPDIR="$HOME"/tmp
   #export TMPDIR

   MC_FOUND=NO

   for wrapper in \
         /usr/local/share/mc/bin/mc-wrapper.sh \
         /usr/local/libexec/mc/mc-wrapper.sh \
         /usr/share/mc/bin/mc-wrapper.sh; do
      if [ -r $wrapper ]; then
         . $wrapper $MC_SLOW $MC_XTERM "$@"
         rc=$?
         MC_FOUND=YES
         break
      fi
   done

   if [ $MC_FOUND = NO ]; then
      for mc in /usr/local/bin/mc /usr/bin/mc; do
         if [ -x $mc ]; then
            MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
            if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
               MC_TMP_DIR="${TMPDIR-/tmp}"
            fi
            MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
            mc_type="`mc_type.py $mc`"
            if [ "$mc_type" = old ]; then
               $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
            elif [ "$mc_type" = new ]; then
               $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
            else
               continue
            fi
            rc=$?
            MC_FOUND=YES
            cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
            break
         fi
      done
   fi

   if [ $MC_FOUND = NO ]; then
      echo "Cannot find mc-wrapper.sh or mc" >&2
      rc=1
   fi

   [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
   [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
   unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
         MC_SLOW MC_TMP_DIR MC_XTERM

   return $rc
}


mkcd() {
   if [ $# -ne 1 ]; then
      echo "Usage: mkcd directory_name" >&2
   elif [ -d "$1" ]; then
      cd "$1"
   elif [ -e "$1" ]; then
      echo "Error: $1 is a file" >&2
   else
      mkdir -p "$1" && cd "$1"
   fi
}


if which tmux >/dev/null 2>&1; then
   tmux() {
      case "$TERM" in
         rxvt)
            TERM=rxvt-unicode command tmux "$@"
         ;;

         *)
            command tmux "$@"
         ;;
      esac
   }
fi


if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
   X() { startx >> .Xserver.log 2>&1; cyr; }
fi

x() { exit; }

This is the page http://phdru.name/Software/dotfiles/shellrc.html. It was generated on Sat, 22 Oct 2016 06:13:20 GMT from CheetahTemplate shellrc.tmpl. Some rights are reserved. Read more about technical aspects of the site.